<?php 
defined("ABSPATH") or exit();
/* 
    Plugin Name: Beem.express Importer
    Author: Beem.express
    Description: Le plugin Beem.express permet l'intégration simplifiée des lots de textes achetés sur la boutique beem.express ainsi que des contenus issus de la rédaction sur-mesure.
    Author URI: https://beem.express
    Version: 1.0
*/
define("FF_PLUGIN_DIR", plugin_dir_path(__FILE__));
define("FF_PLUGIN_URL", plugin_dir_url(__FILE__));


function wp_register_ff_csv_dashboard() {

    add_menu_page(
        __( 'Import CSV', 'ff-csv' ),
        'Beem.Express Importer',
        'manage_options',
        FF_PLUGIN_DIR."/includes/ff-importer.php",
        '',
        '',
        1
    );
}
add_action( 'admin_menu', 'wp_register_ff_csv_dashboard' );


function wp_ff_csv_importer() {
/*     error_reporting(1);
    ini_set('display_errors',1); */
    if (!wp_verify_nonce($_POST['_wpnonce'], 'csv_images') || !current_user_can('manage_options')) {
        return;
    }
    global $wpdb;

/*     $upload_path = FF_PLUGIN_DIR.'/uploads/';

    if (!is_dir($upload_path)) {
        mkdir($upload_path);
        chmod($upload_path, 0755);
    }
 */
    $images_list = explode("\n", $_POST['images_list']);

    foreach ($images_list as $imlist => $key) {
        $images_data[$imlist] = trim($key);
    }


    foreach ($_FILES['files_images']['name'] as $key => $file) {

        $file_path = $upload_path.$file;
        $file_url = $upload_path.$file;
        $tmp_name = $_FILES['files_images']['tmp_name'][$key];
        $file_type = $_FILES['files_images']['type'][$key];
   

        $wordpress_upload_dir = wp_upload_dir();
        $new_file_path = $wordpress_upload_dir['path'] . '/' . $file;
        $new_file_mime = mime_content_type( $tmp_name );

        if( move_uploaded_file($tmp_name , $new_file_path ) ) {
        
        
            $upload_id = wp_insert_attachment( array(
                'guid'           => $new_file_path, 
                'post_mime_type' => $new_file_mime,
                'post_title'     => preg_replace( '/\.[^.]+$/', '', $file ),
                'post_content'   => '',
                'post_status'    => 'inherit'
            ), $new_file_path );
        
            require_once( ABSPATH . 'wp-admin/includes/image.php' );
        
            wp_update_attachment_metadata( $upload_id, wp_generate_attachment_metadata( $upload_id, $new_file_path ) );
        
            $thumbnails[$file] = $upload_id;

        }
    

    }

    foreach ($_FILES['files']['name'] as $key => $file) {

        $file_path = $upload_path.$file;
        $file_url = $upload_path.$file;
        $tmp_name = $_FILES['files']['tmp_name'][$key];
        $file_type = $_FILES['files']['type'][$key];
        
        if ($file_type == "text/csv" || $file_type == "application/vnd.ms-excel") {
            $csv_name = $file;

            $csv_tmp = file_get_contents($tmp_name);
            //move_uploaded_file($tmp_name, $file_path);
        } 

        break;
    }


    $csvpath = $upload_path.$csv_name;

    $csv = str_getcsv($csv_tmp, "\n");

    if (!empty($csv)){//($handle = fopen($csvpath, "r")) !== FALSE) {
        $c = 0;
        $counting = 0;
        $daysweek = 1;
        $cp = 0;
        foreach ($csv as $row) {//while (($data = fgetcsv($handle, 99999999, "*")) !== FALSE) {
            $data = str_getcsv($row, '*');
            if ($c == 0) {
                $c++;
                continue;
            }
            $title = $data[0];
            $seo_title = $data[1];
            $slug = $data[2];
            $post_content = $data[3];
            
            $date_from = $_POST['date_random_from'];
            $date_to = $_POST['date_random_to'];

            $post_type = ($_POST['post_type'] == "post") ? 'post' : 'page'; 

            $schedule_type = $_POST['schedule_type'];
            $post_status = ($_POST['post_status'] == "publish") ? "publish" : "draft";
            $numbers = ($_POST['post_in'] == 1) ? 1 : intval($_POST['post_in']) - 1;

        
            if ($schedule_type == "day") {
                $stype = "days";
            } elseif ($schedule_type == "week") {
                $stype = "weeks";
            }           
          

            if ($schedule_type != "now" && $schedule_type != "random") {
                if ($counting > $numbers || $counting == 0) {
                    $new_date = new DateTime($date_from);
                    $new_date->modify('+'.$daysweek.' '.$stype);
                    $date = strtotime($new_date->format('Y-m-d'));
                    $counting = 0;
                    $daysweek++;
                }
            } elseif ($schedule_type == "random") {
                $date = strtotime(date("Y-m-d H:00:00", rand(strtotime(date($date_from)), strtotime(date($date_to)))));
            }
                      

            $today_date = strtotime(date("Y-m-d H:i:s"));
       
            
            if ($date > $today_date) {
                $post_status = 'future';
            } 

      
            if (empty($post_content)) {
                continue;
            }

            $post_data = array(
                "post_title" => $title,
                "post_name" => $slug,
                "post_content" => $post_content,
                "post_type" => $post_type,
                "post_status" => $post_status
            );
            

            if ($post_status == "future" || !empty($date)) {
                $post_data['post_date'] = date("Y-m-d H:i:s", $date);
            }
    

            $formated_date = date("Y-m-d H:i:s", $date);

            $post_id =  wp_insert_post($post_data);

            $posts[] = $post_id;

            $thumbnail_id = $thumbnails[$images_data[$cp]];


            if (isset($thumbnail_id)) {
                update_post_meta($post_id, "_thumbnail_id",  $thumbnail_id);
            }

        
            update_post_meta($post_id, '_seopress_titles_title', $seo_title);
            update_post_meta($post_id, '_yoast_wpseo_title', $seo_title);
            update_post_meta($post_id, '_aioseo_title', $seo_title);
            update_post_meta($post_id, '_aioseo_og_title', NULL);
            
            $wpdb->insert($wpdb->prefix."aioseo_posts", array("title" => $seo_title, "post_id" => $post_id, "created" => $formated_date, "updated" => $formated_date ));

            update_post_meta($post_id, 'rank_math_title', $seo_title);
            
            $counting++;
            $c++;
            $cp++;
        }

    
        /* fclose($handle);
    
        unlink($csvpath);
 */
        $wpnonce = wp_create_nonce('completed_post');

        $success_url = "admin.php?page=beem-express-importer%2Fincludes%2Fff-importer.php&post_ids=".urlencode(implode(',',$posts)).'&update-category='.$wpnonce.'&published-post-type='.$post_type.'&success=true';

        wp_redirect($success_url);
        exit();
    }
}

add_action('admin_init', 'wp_ff_csv_importer');

function wp_ff_save_category() {
    if (!wp_verify_nonce($_POST['_wpnonce'], 'save_category') || !current_user_can('manage_options')) {
        return;
    }

    $cats = $_POST['post_category'];

    foreach ($cats as $pid => $cat) {
        wp_set_post_categories($pid, $cat);  
    }
    
    $wpnonce = wp_create_nonce('saved_category');

    $success_url = 'admin.php?page=beem-express-importer%2Fincludes%2Fff-importer.php&success='.$wpnonce;

    wp_redirect($success_url);
    exit();
}

add_action('admin_init', 'wp_ff_save_category');


function wp_ff_save_all_category() {
    if (!wp_verify_nonce($_POST['_wpnonce'], 'save_all_category') || !current_user_can('manage_options')) {
        return;
    }

    $cats = $_POST['all_posts'];
    $posts = explode(',', $_POST['posts_list']);


    foreach ($posts as $pid) {
        //foreach ($cats as $cat) {
            wp_set_post_categories($pid, $cats);  
        //}
    }
    
    $wpnonce = wp_create_nonce('saved_category');

    $success_url = 'admin.php?page=beem-express-importer%2Fincludes%2Fff-importer.php&success='.$wpnonce;

    wp_redirect($success_url);
    exit();
}

add_action('admin_init', 'wp_ff_save_all_category');
