<?php defined("ABSPATH") or exit(); 

if (wp_verify_nonce($_GET['success'], 'saved_category') || $_GET['success']) {
?>
<div class="notice notice-success is-dismissible">
        <p><?php _e( 'Votre contenu a été importé avec succès', 'ff-importer' ); ?></p>
    </div>
<?php
}
?>


<h1>Beem.express CSV Importer</h1>
<hr>


<div class="postbox-container" style="width:50%;">
    <div class="postbox">
            <div class="postbox-header"><h2 class="hndle ui-sortable-handle" style="margin-left:10px;">CSV et images</h2></div>
        <div class="inside">
            <form method="POST" enctype="multipart/form-data">
            <?php echo wp_nonce_field('csv_images') ?>
            <p>
                <label for="files">Importez votre CSV</label><br>
                <input type="file" id="files" accept="text/csv" multiple="multiple" name="files[]">
            </p>

            <p>
                <label for="files_images">Importez vos images</label><br>
                <input type="file" id="files_images" multiple="multiple" name="files_images[]">
            </p>

            <p>
                <label for="files_images_list">Liste des noms de vos images</label><br>
                <textarea name="images_list" id="files_images_list" cols="30" rows="10"></textarea>
            </p>

            <p>

                <label for="post_status">Statut de la publication</label><br>
                <select name="post_status" id="post_status">
                    <option value="publish" selected="selected">Publié</option>
                    <option value="draft">Brouillon</option>
                </select>
            </p>

            <p>

                <label for="post_type">Type de publication</label><br>
                <select name="post_type" id="post_type">
                    <option value="post">Article</option>
                    <option value="page">Page</option>
                </select>
                </p>

                <p>

                <label for="schedule_type">Programmation des publications</label><br>
                <select name="schedule_type" id="schedule_type">
                    <option value="now">Maintenant</option>
                    <option value="week">Par semaine</option>
                    <option value="day">Par jour</option>
                    <option value="random">Aléatoire</option>
                </select>
                </p>
                <p>

                <label for="post_in">Nombre de publications à réaliser</label><br>
                <input type="number" name="post_in" placeholder="Par exemple : 3 par jour/semaine ou laisser blanc si aléatoire">
                </p>

                <p>
                    <label for="post_in">Dates (pour la fonction aléatoire seulement)</label><br>
                    <input type="date" name="date_random_from">
                    <p>Jusqu'à</p>
                    <input type="date" name="date_random_to">
                </p>
            
            <p><input type="submit" class="button button-primary button-large" name="importer" value="Importer !"></p>
            </form>
        </div>
    </div>
</div>


<?php if (wp_verify_nonce($_GET['update-category'], 'completed_post') && $_GET['published-post-type'] == "post"): 
    
    $posts_id = explode(',', urldecode($_GET['post_ids']));
  
?>

<div class="postbox-container" style="width:90%;">
    <div class="postbox">
            <div class="postbox-header"><h2 class="hndle ui-sortable-handle" style="margin-left:10px;">Sélection des catégories</h2></div>
        <div class="inside">
        <form method="POST">
    <input type="hidden" name="posts_list" value="<?php echo implode(',',$posts_id) ?>">
<ul>

<?php 
        $categories = get_categories( array(
            'hide_empty' => false
        ) );


?>
    <li>
    
        <p>
           <h2>Choisir les catégories pour toutes les publications</h2>

            <select name="all_posts[]" multiple="multiple">
            <?php foreach ($categories as $cat):
                    if ($cat->parent == 0) {
                        $cat_children = get_term_children($cat->term_id, 'category');
                        ?>
                    <option value="<?php echo $cat->term_id ?>" id="<?php echo $post->ID.$cat->term_id ?>"><?php echo $cat->name ?></option>

                            <?php foreach ($cat_children as $catc):
                                
                                $cc = get_category($catc);
                                ?>
                               <option value="<?php echo $cc->term_id ?>"><?php echo $cc->name ?></option>
                            <?php endforeach ?>
                 
<?php
                    }
                ?>
                
            <?php endforeach ?>
            </select>

        </p>
        
    </li>

</ul>
<?php wp_nonce_field('save_all_category') ?>
<p><input type="submit" class="button button-primary button-large" name="save_all_category" value="Envoyer"></p>

</form>


                    <h3>Ou</h3>
                    <h2>Choisir les catégories pour chaque publication</h2>

            <form method="POST">

            <ul>

            <?php 
                foreach ($posts_id as $pid):
                    $pid = intval($pid);
                    $post = get_post($pid);


                    if (empty($post) || $post->post_type == "page") {
                        continue;
                    }


                    $categories = get_categories( array(
                        'hide_empty' => false
                    ) );

            
            ?>
                <li>
                
                    <p>
                       <h2><?php echo $post->post_title ?></h2>

                        <select name="post_category[<?php echo $pid ?>][]" multiple="multiple">
                        <?php foreach ($categories as $cat):
                                if ($cat->parent == 0) {
                                    $cat_children = get_term_children($cat->term_id, 'category');
                                    ?>
                                <option value="<?php echo $cat->term_id ?>" id="<?php echo $post->ID.$cat->term_id ?>"><?php echo $cat->name ?></option>

                                        <?php foreach ($cat_children as $catc):
                                            
                                            $cc = get_category($catc);
                                            ?>
                                           <option value="<?php echo $cc->term_id ?>"><?php echo $cc->name ?></option>
                                        <?php endforeach ?>
                             
<?php
                                }
                            ?>
                            
                        <?php endforeach ?>
                        </select>

                    </p>
                    
                </li>
            <?php
                endforeach;
            ?>
            </ul>
            <?php wp_nonce_field('save_category') ?>
            <p><input type="submit" class="button button-primary button-large" name="save_category" value="Envoyer"></p>

            </form>

        </div>
    </div>
</div>
<?php endif; ?>
<script>
jQuery('#files_images').change(function(){
    var f = jQuery(this).prop('files');
    var n = f.length - 1;
    var c = 0;
    var list_text = "";
    while (c <= n) {
		if (c == 0) {
		   list_text = f[c].name;
		} else {
	       list_text += "\n"+f[c].name;
		}
        c++;
    }
    jQuery("#files_images_list").val(list_text);
});
</script>